import pandas as pd
from sklearn.model_selection import cross_val_score
from sklearn.linear_model import LinearRegression

train_data = pd.read_csv('train_data.csv', index_col = 'ID')
y_train = train_data.pop('deliver_time')
test_data = pd.read_csv('test_data.csv', index_col = 'ID')

subtask1 = len(test_data.loc[test_data['Weather'] == 'Fog'].loc[test_data['City A'] == 'Barlad'])

for dataframe in [train_data, test_data]:
    dataframe['Clear weather'] = dataframe['Weather'].map(lambda x : 1 if x == 'Clear' else 0)
    dataframe.pop('Weather')

# drop start and end cities 
for dataframe in [train_data, test_data]:
    for column in ['City A', 'City B']:
        dataframe.pop(column)

model = LinearRegression()
# uncomment to test your model:
# scores = cross_val_score(model, train_data, y_train, scoring = 'neg_mean_absolute_error', cv = 5)
# print(-scores.mean())

model.fit(train_data, y_train)
preds = model.predict(test_data)

sample = pd.read_csv('sample_output.csv', index_col = 'Unnamed: 0')
sample.loc[sample['subtaskID'] == 2, 'answer'] = preds
sample.loc[sample['subtaskID'] == 1, 'answer'] = subtask1
sample.to_csv('output.csv')

